import java.util.Vector;
import java.lang.*;

public class Checkers {
	
	private static Vector players;
	private Board b;
	private Board lastBoard;
	private Board lastlastBoard;
	private static int currentPlayer;
	
	public Checkers() {
		players = new Vector();
	}
	
	public void addPlayer (Player p) {
		p.setPlayerNumber (players.size());
		players.add (p);
	}
	
	public static int getCurrentPlayer() {
		return currentPlayer;
	}

	public static Player currentMover() {
		return (Player) players.elementAt(currentPlayer);
	}

	public void startGame() {
		b = new Board();
		lastBoard = new Board (b);
		lastlastBoard = new Board (lastBoard);
		
		for (int i=1; i < 13; i++) {
			Piece p = new Piece (i, 0);
			b.addPiece (p);
		}
		
		for (int i=21; i < 33; i++) {
			Piece p = new Piece (i, 1);
			b.addPiece (p);
		}		
		b.output();
		
		int ply = 0;
		Player p = (Player) players.elementAt (ply%2);
		while (true) {
			currentPlayer = ply%2;
			try {
				p = (Player) players.elementAt (ply%2);
				String move = p.makeMove(b);
				
				if (move.equals ("U") || move.equals ("u")) {
					b = new Board (lastlastBoard);
					move = p.makeMove(b);
				}
				String[] placesStr = move.split ("-");
				int[] places = new int[placesStr.length];
			
				for (int i=0; i < placesStr.length; i++) {
					places[i] = new Integer (placesStr[i]).intValue();
				}

				System.out.println (move);
				
				lastlastBoard = new Board (lastBoard);
				lastBoard = new Board (b);
				for (int i=0; i < placesStr.length - 1; i++) {
					Piece piece = b.pieceAt (places[i]);
					if (piece != null) {
						if (b.validMove (places[i], places[i+1], ply%2)) {
							Piece jumped = b.jumpedPiece (places[i],places[i+1]);						
							if (jumped != null) {
								b.removePiece (jumped);
							}
							
							b.removePiece (piece);
							piece.movePiece (places[i+1]);
							b.addPiece (piece);
						} else {
							throw new Exception ("Bad move, try again.");
						}
						piece = null;
					} else {
						throw new Exception ("Grabbing at air, aren't you?");
					}
				}
				System.out.println ("***************************");
				System.out.println ("The last move was: " + move);
				System.out.println ("***************************");
				
				if (b.numPieces ((ply+1)%2) == 0) {
					System.out.println ("Congratulations, " + ((Player) players.elementAt((ply+1)%2)).getName() + ".  You Lose, errr, Win!");
					System.out.println ("And it only took you " + ply + " ply, or " + ply/2 + " moves.");
					System.exit(0);
				}
				ply++;
				move = null;
				p = null;
			} catch (Exception e) {
				System.err.println ("That was an invalid move, " + p.getName() + ", try again.");
//				e.printStackTrace();
			}
		}
	}
}
